#include "capture.h"

void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/* ----------------   PWMź ںռձȵļ--------------- */
// arr ԶװؼĴֵ
// clk_cntʱӣ Fck_int / (psc+1) = 72M/(psc+1)
// PWMźŵ T = (arr +1)* (1/clk_cnt) = arr*(psc+1) / 72M
// ռձP=CCR/(arr+1)
/*******************************************************************************
* Function Name  : Input_Capture_Init
* Description    : Initializes TIM1 input capture.
* Input          : arr: the period value.
*                  psc: the prescaler value.
*                  ccp: the pulse value.
* Return         : None
*******************************************************************************/
void Input_Capture_Init( u16 arr, u16 psc )
{
    GPIO_InitTypeDef        GPIO_InitStructure={0};
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure={0};
    TIM_ICInitTypeDef       TIM_ICInitStructure={0};
    NVIC_InitTypeDef        NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE );//ʹGPIOAʱӺTIM2ʱ
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM2, ENABLE);

    GPIO_PinRemapConfig(GPIO_FullRemap_TIM2, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init( GPIOA, &GPIO_InitStructure);
    GPIO_ResetBits( GPIOA, GPIO_Pin_15 );

    //ʱڣʵʾ趨ԶؼĴ ARR ֵ ARR ΪҪװصʵԶؼĴӰӼĴ ֵ ÷ΧΪ 0  65535
    TIM_TimeBaseInitStructure.TIM_Period = arr;
    //ʱԤƵãʱԴԤƵǶʱʱCK_CNT趨 PSC Ĵֵ
    //㹫ʽΪ ʱƵ (fCK_CNT) fCK_PSC / (PSC[15:0] + 1)ʵ 1  65536 Ƶ
    TIM_TimeBaseInitStructure.TIM_Prescaler = psc;
    //ʱӷƵöʱʱ CK_INT ƵԼ˲ʱƵʷƵȡѡ 1 2 4 Ƶ
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up; //üģʽϼģʽ
    TIM_TimeBaseInitStructure.TIM_RepetitionCounter =  0x00;        //ظֵ0ظֻ 8 λֻڸ߼ʱ
    TIM_TimeBaseInit( TIM2, &TIM_TimeBaseInitStructure); //ʼ

    // PWM벶ģʽʱ,ֻҪôźŵһ·ɣڲڣ
    // һ·ڲռձȣӲԴãҪ

    // TIM_Channelͨ ICx ѡ񣬿ѡ TIM_Channel_1 TIM_Channel_2TIM_Channel_3  TIM_Channel_4 ĸͨ
    TIM_ICInitStructure.TIM_Channel = TIM_Channel_1;
    //벶ԤƵֵҪźŵÿЧأ 1 Ƶ 
    TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1;
    //벶˲ãѡ 0x0  0x0F趨 CHCTLRx ĴICxF[3:0]λֵһǲʹ˲Ϊ 0
    TIM_ICInitStructure.TIM_ICFilter = 0x0;
    //벶شѡ񣬿ѡش½ش䴥
    TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising;
    //ͨѡ񣬲ͨ ICx źſֱͨΪTIM_ICSelection_DirectTI TIM_ICSelection_IndirectTI  TIM_ICSelection_TRC
    TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI;

    TIM_PWMIConfig( TIM2, &TIM_ICInitStructure );

    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;       //TIM1Ƚж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;//ռȼ
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;       //Ӧȼ
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;          //ʹͨ
    NVIC_Init(&NVIC_InitStructure);

    TIM_ITConfig( TIM2, TIM_IT_CC1, ENABLE ); //ʹTIM1ж

    // ѡ벶Ĵź
    TIM_SelectInputTrigger(TIM2, TIM_TS_TI1FP1);

    // ѡģʽ: λģʽ
    // PWMģʽʱ,ģʽ빤ڸλģʽʼʱ,CNTᱻλ
    TIM_SelectSlaveMode(TIM2, TIM_SlaveMode_Reset);
    TIM_SelectMasterSlaveMode(TIM2,TIM_MasterSlaveMode_Enable);
    TIM_Cmd( TIM2, ENABLE );  //ʱʹ
}

 u16 IC2Value = 0;
 u16 IC1Value = 0;
/*******************************************************************************
* Function Name  : TIM1_CC_IRQHandler
* Description    : This function handles TIM1  Capture Compare Interrupt exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void TIM2_IRQHandler(void)
{

    if( TIM_GetITStatus( TIM2, TIM_IT_CC1 ) != RESET )   //Ƚ1ж
    {
        printf( "cycle:%d\r\n", (TIM_GetCapture1(TIM2)+1) );      //ӡõĲȽ1Ĵֵֵ1ʾ
        TIM_SetCounter( TIM2, 0 );
    }
    TIM_ClearITPendingBit( TIM2, TIM_IT_CC1 ); //TIM1Ƚ1жϹλ



}

